<?

/* php_passport_check 0.1	checks passport ids if valid or not
Copyright (C) 2002 Oliver Lenzko <oliver at lenzko dot de>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


*/

//	Settings - see README for details
	$php_passport_min_holder_age = 10;	// Minimum age of passport holder
	$php_passport_max_ttl = 30; 	// Maximum age for a passport - stupid two letter years

	function php_passport_checkdate($y, $m, $d) {
		return (date("Ymd", mktime(0,0,0,$m,$d,$y)) == "$y$m$d");
	}
	
	function php_passport_checksum($s) {
		$multiplikator = array(7,3,1);
		$num = 0;
		$mult = 0;
		for ($i=0; $i < strlen($s); $i++) {
			$c = substr($s,$i,1);
			if (!is_numeric($c)) return -1;	// cannot be a checksum
			$num += $c * $multiplikator[$mult];
			$mult = ++$mult % 3;
		}
		return $num % 10;
	}

	function php_passport_checkid($id) {
		global $php_passport_min_holder_age;
		global $php_passport_max_ttl;
		$min_holder_age = $php_passport_min_holder_age;
		$max_ttl = $php_passport_max_ttl;

		$id = str_replace(" ", "", $id); //remove spaces

		$passport_no = substr($id,0,9);
		$passport_no_cs = substr($id,9,1);
		$date_of_birth = substr($id,13,6);
		$date_of_birth_cs = substr($id,19,1);
		$date_of_expiry = substr($id,21,6);
		$date_of_expiry_cs = substr($id,27,1);
		$all_numbers = 
			$passport_no .
			$passport_no_cs.
			$date_of_birth .
			$date_of_birth_cs .
			$date_of_expiry .
			$date_of_expiry_cs;
		$all_numbers_cs = substr($id,strlen($id)-1,1);

		if (php_passport_checksum($passport_no)!=$passport_no_cs) return array("status"=>false, "error_code"=>"INVALID_NUMBER");
		if (php_passport_checksum($date_of_birth)!=$date_of_birth_cs) return array("status"=>false, "error_code"=>"INVALID_NUMBER");
		if (php_passport_checksum($date_of_expiry)!=$date_of_expiry_cs) return array("status"=>false, "error_code"=>"INVALID_NUMBER");
		if (php_passport_checksum($all_numbers)!=$all_numbers_cs) return array("status"=>false, "error_code"=>"INVALID_NUMBER");

		$current_yy = date("Y",time());
		$current_century = substr($current_yy,0,2);
		$current_y = substr($current_yy,2,2);
		$current_m = date("m", time());
		$current_d = date("d", time());

		$dob_y = substr($date_of_birth,0,2);
		$dob_m = substr($date_of_birth,2,2);
		$dob_d = substr($date_of_birth,4,2);
		$doe_y = substr($date_of_expiry,0,2);
		$doe_m = substr($date_of_expiry,2,2);
		$doe_d = substr($date_of_expiry,4,2);

		// guess the centuries
		$dob_y = (($current_century+1)."00") + $dob_y;
		while ($dob_y > $current_yy - $min_holder_age) $dob_y -=100;
		$doe_y = (($current_century+1)."00") + $doe_y;
		while ($doe_y > $current_yy+$max_ttl) $doe_y -= 100;

		if (!php_passport_checkdate($dob_y, $dob_m, $dob_d) ||
			!php_passport_checkdate($doe_y, $doe_m, $doe_d))
			return array("status"=>false, "error_code"=>"INVALID_NUMBER");

		$age = $current_yy - $dob_y;
		if ($dob_m > $current_m || ($dob_d > $current_d && $dob_m == $current_m))
			$age--;

		if (mkTime(0,0,0,$doe_m,$doe_d,$doe_y)<time())
			return array("status"=>false, "error_code"=>"PASSPORT_EXPIRED", "age"=>$age);

		return array("status"=>true, "age"=>$age);
	}

?>